from ctypes import *
lib = CDLL('./libcall.so')

target = lib.target
target.restype = c_double
target.argtypes = [c_double] * 8 + [ c_long, c_double]

target_vfp_only = lib.target_vfp_only
target_vfp_only.restype = c_double
target_vfp_only.argtypes = [c_double] * 10

def call_and_check(f, args):
  exp =sum([a.value for a in args])
  res = f(*args)
  if not res == exp:
    print("Fail %f != %f" % (res, exp))

args = [c_double(float("%d.%d" % (i,i))) for i in range(1,9)] + [c_long(10), c_double(9.9)]
call_and_check(target, args)

args = [c_double(float("%d.%d" % (i,i))) for i in range(1,11)]
call_and_check(target_vfp_only, args)
