#include <stdio.h>
#include <ffi.h>

double target(double a, double b, double c, double d, double e, double f, double g, double h, long int i, double j) {
	return a + b + c + d + e + f + g + h + j + (double) i;
}

double target_vfp_only(double a, double b, double c, double d, double e, double f, double g, double h, double i, double j) {
	return a + b + c + d + e + f + g + h + j + i;
}

double ffi_target_vfp_only() {
	ffi_cif cif;
	ffi_type *args[10];
	double dv[10] = {1.1, 2.2, 3.3, 4.4, 5.5, 6.6, 7.7, 8.8, 9.9, 10.1};
	void *values[10];
	double rc = 0.5;

	/* Initialize the argument info vectors */
	int i;
	for(i = 0; i < 10; i++) {
		args[i] = &ffi_type_double;
		values[i] = &dv[i];
	}

	/* Initialize the cif */
	if (ffi_prep_cif(&cif, FFI_DEFAULT_ABI, 10, &ffi_type_double, args) == FFI_OK) {
		ffi_call(&cif, FFI_FN(target_vfp_only), &rc, values);
	}
	return rc;
}

double ffi_target()
{
	ffi_cif cif;
	ffi_type *args[10];
	double dv[10] = {1.1, 2.2, 3.3, 4.4, 5.5, 6.6, 7.7, 8.8, 9.9};
	long int arg = 10;
	void *values[10];
	double rc = 0.5;

	/* Initialize the argument info vectors */
	int i;
	for(i = 0; i < 8; i++) {
		args[i] = &ffi_type_double;
		values[i] = &dv[i];
	}
	args[8] = &ffi_type_slong;
	values[8] = &arg;
	args[9] = &ffi_type_double;
	values[9] = &dv[8];

	/* Initialize the cif */
	if (ffi_prep_cif(&cif, FFI_DEFAULT_ABI, 10, &ffi_type_double, args) == FFI_OK) {
		ffi_call(&cif, FFI_FN(target), &rc, values);
	}
	return rc;
}

int main(void* args)
{
	double a = target(1.1, 2.2, 3.3, 4.4, 5.5, 6.6, 7.7, 8.8, 10, 9.9);
	double b = ffi_target();
  printf("Result of direct call: %f\n", a);
  printf("Result of call using libffi: %f\n", b);

  a = target_vfp_only(1.1, 2.2, 3.3, 4.4, 5.5, 6.6, 7.7, 8.8, 9.9, 10.1);
	b = ffi_target_vfp_only();
  printf("Result of direct call: %f\n", a);
  printf("Result of call using libffi: %f\n", b);
	return 0;
}

